package legion.muyue.best2048;

import android.util.Log;
import java.util.ArrayList;
import java.util.Random;

public class Game {

    private int[][] gameBoard;
    private Random random;

    // Constructeur
    public Game() {
        gameBoard = new int[4][4];
        random = new Random();
    }

    // Méthode pour afficher la grille (pour les tests)
    public void printArray() {
        for (int[] row : gameBoard) {
            String rowString = String.format("%6d%6d%6d%6d", row[0], row[1], row[2], row[3]);
            Log.d("Game", rowString);
        }
    }

    public void addNewNumbers() {
        ArrayList<int[]> emptySpaces = new ArrayList<>();

        // Trouve toutes les cases vides (valeur 0)
        for (int x = 0; x < 4; x++) {
            for (int y = 0; y < 4; y++) {
                if (gameBoard[x][y] == 0) {
                    emptySpaces.add(new int[]{x, y}); // Ajoute les coordonnées (x, y)
                }
            }
        }

        // S'il y a des cases vides
        if (!emptySpaces.isEmpty()) {
            // Choisit une case vide au hasard
            int choice = random.nextInt(emptySpaces.size());
            int[] coordinates = emptySpaces.get(choice);
            int x = coordinates[0];
            int y = coordinates[1];

            int newNumber;
            int randomNumber = random.nextInt(100); // Génère un nombre aléatoire entre 0 et 99

            if (randomNumber < 85) { // 85% de chance d'avoir un 2
                newNumber = 2;
            } else if (randomNumber < 95) { // 10% de chance d'avoir un 4 (de 85 à 94)
                newNumber = 4;
            } else { // 5% de chance d'avoir un 8 (de 95 à 99)
                newNumber = 8;
            }

            // Place la nouvelle tuile sur la grille
            gameBoard[x][y] = newNumber;
        }
    }
}